#!/usr/bin/python
import numpy as np
import csv
#A sequence generator - it creates combinations of sequences in a text file for the the tests to decode


def __mkseq(num,seq):
	fseq = []
	for i in seq[num]:
		if (i>=alphabet):
			fseq +=__mkseq(i-alphabet,seq)
		else:
			fseq.append(i)
	return fseq

def mkSequence(alphabet,basic,advanced,ssize,seqlen):
	sequence = {
		'alphabet': alphabet,	#The letters in the alphabet
		'basic': basic,			#Number of basic subsequences
		'advanced': advanced,	#Numer of Advanced subsequences
		'seqsize': ssize,		#Average subsequence length
		'seqlen': seqlen		#Length of total sequence
	}
	
	seq = []

	#Create the basic sequences
	for i in xrange(basic):
		seq.append(np.floor(np.random.random_sample((ssize,))*alphabet).astype(np.int))

	#Creates the "advanced" sequences
	sssize = alphabet+basic
	for i in xrange(ssize):
		seq.append(np.floor(np.random.random_sample((ssize,))*(sssize+i)).astype(np.int))

	#Decides the order of sequences
	sorder = np.floor(np.random.random_sample((seqlen/ssize,))*len(seq)).astype(np.int)

	final = []
	for i in sorder:
		final+=__mkseq(i,seq)
	sequence['sequence'] = final
	sequence['seqlen'] = len(final)
	sequence['subseq'] = seq
	
	return sequence

def writeSequence(s,fname):
	f = open(fname,'w')
	f.write('Sequence File,1\n')
	f.write("Alphabet,BasicSequences,AdvancedSequences,SequenceSize,FullSize\n")
	f.write(str(s['alphabet'])+','+str(s['basic'])+','+str(s['advanced'])+','+str(s['seqsize'])+','+str(s['seqlen'])+'\n')
	for i in s['sequence']:
		f.write(str(i)+',')
	f.write('\n')
	for j in s['subseq']:
		for i in j:
			f.write(str(i)+',')
		f.write('\n')
	f.close()

def readSequence(fname):
	s = {}
	f = open(fname,'r')
	reader = csv.reader(f,delimiter=',')
	data = []
	for row in reader:
		data.append(row)
		if (data[-1][-1]==''):
			data[-1] = data[-1][0:-1]
	f.close()
	s['alphabet']=int(data[2][0])
	s['basic']=int(data[2][1])
	s['advanced']=int(data[2][2])
	s['seqsize']=int(data[2][3])
	s['seqlen']=int(data[2][4])
	
	s['sequence']=np.array(data[3]).astype(np.int)	#It ends with an empty cell
	
	s['subseq']=np.array(data[4:]).astype(np.int)
	return s
if (__name__=='__main__'):
	fname = "test.csv"		#The file to save the sequence in
	#weave = 0				#How many sequences to weave together on average
	bseqs = 3				#Basic sequences - only use built-in alphabet
	seqs = 2				#Advanced sequences - use alphabet+subsequences
	alphabet = 8			#Alphabet length
	slen =100				#The minimum size of the final sequence
	seqsize = 5			#Average size of a sequence
	
	writeSequence(mkSequence(alphabet,bseqs,seqs,seqsize,slen),fname)
	#writeSequence(readSequence(fname),'file2.csv')
