/**************************************************************************************

                               Data Storage Functions

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_DATA
#	define NDB_DATA

#include "ndb_def.h"

//The variable types
#define NDB_TU8		1	//uint8
#define NDB_TU16	2	//uint16
#define NDB_TU32	3	//uint32
#define NDB_TU64	4	//uint64
#define NDB_TSTR	5	//String

//Sizes
#define NDB_TSU8	1	//uint8
#define NDB_TSU16	sizeof(uint16_t)	//uint16
#define NDB_TSU32	sizeof(NDB_SIZE)	//uint32
#define NDB_TSU64	sizeof(uint64_t)	//uint64
#define NDB_TSSTR	(sizeof(NDB_LOC)+sizeof(int16_t))	//String


//------------------------------------------------------------------------------------
//Extracting data from a table row

//Get the size in bytes of a table row
NDB_SIZE ndb_dtSize(nDB* db, NDB_LOC tbl);

//Creates and deletes table in data slot of node
void ndb_dataMk(nDB* db, NDB_LOC loc, uint8_t tbl);
void ndb_dataDel(nDB* db, NDB_LOC loc, NDB_LOC tbl);

//Gets and sets variables in a table, given values
void ndb_dataSetU8(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field,uint8_t p);
void ndb_dataSetU16(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field,uint16_t p);
void ndb_dataSetU32(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field, NDB_SIZE p);
void ndb_dataSetU64(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field, uint64_t p);
void ndb_dataSetS(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field, char* p);

uint8_t ndb_dataGetU8(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field);
uint16_t ndb_dataGetU16(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field);
NDB_SIZE ndb_dataGetU32(nDB* db, NDB_LOC loc,NDB_LOC tbl, uint8_t field);
uint64_t ndb_dataGetU64(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field);
char* ndb_dataGetS(nDB* db, NDB_LOC loc, NDB_LOC tbl, uint8_t field);



#endif
//EOF

