/**************************************************************************************

                               Listing Data Index

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_LINDEX
#	define NDB_LINDEX

#include "ndb_def.h"
/*
	The simplex index - a list. The only difference between indexes and other structures is that
	they are absolutely required to have identifiers, so that index types can be switched on the fly
*/

NDB_LOC ndb_liGetnum(nDB* db, NDB_LOC i);	//Gets the number of elements in the index

NDB_LOC ndb_liMk(nDB* db,uint8_t lesize, NDB_LOC first, NDB_LOC prev);	//Creates an empty index - ready for receiving data

NDB_LOC ndb_liAdd(nDB* db, NDB_LOC index);		//Adds a new element to the index - returns the element's location
NDB_LOC ndb_liGet(nDB* db, NDB_LOC index, NDB_LOC num);	//Gets an arbitrary element to the index

//Initialize the iterator
char ndb_liIterinit(nDB* db, NDB_LOC n, ndb_iter* i);

//Get or add
NDB_LOC ndb_liIterget(ndb_iter* i, NDB_LOC num);	//Gets an arbitrary element
NDB_LOC ndb_liIteradd(ndb_iter* i);					//Add an element using iterator

//Iterate forward and back on the index
NDB_LOC ndb_liIterate(ndb_iter* i);
NDB_LOC ndb_liIterateback(ndb_iter* i);

NDB_LOC ndb_liIteratecur(ndb_iter* i);	//Iterates the current item

#endif
//EOF

