/**************************************************************************************

                                     Logging
                                     Header

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_LOGH
#	define NDB_LOGH

#include "ndb_def.h"

//-------------------------------------------------------------------------------------

#if NDB_LOG		
//If NDB_LOG is 1, so the log exists

#include <stdio.h>	//The log file is written using stdio routines

FILE* ndb_logGetFile();
void ndb_logSetFile(FILE* f);
uint8_t ndb_logGetLevel();
void ndb_logSetLevel(uint8_t level);

void ndb_slog(uint8_t level, char* str, ...);
void ndb_log_(char* f, uint32_t l, uint8_t level, char* str, ...);
#define ndb_log(...) ndb_log_(__FILE__,__LINE__,__VA_ARGS__)


#else
//NDB_LOG is 0, so we don't include logging functions, we just include empty defintions

#define ndb_logGetFile() NULL
#define ndb_logSetFile(a) 
#define ndb_logGetLevel() 0
#define ndb_logSetLevel(a) 
#define ndb_slog(...) 
#define ndb_log(...)

#endif

#endif
//EOF

