/**************************************************************************************

                                    nDB Mapper
                           Database Memory Manipulation

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_MAPPER
#	define NDB_MAPPER

#include "ndb_def.h"

//Mapping for in-memory databases (it just uses malloc and realloc)
char ndb_mapMem(nDB* db);						//Allocate to map (use size in db->size)
char ndb_mapMemResize(void* db, NDB_LOC size);	//Resize map to new size
void ndb_mapMemClose(void* db);					//Closes the memory map

//Memory mapping for file databases - this includes system-specific code!
char ndb_mapFile(nDB* db, char* filename);		//Uses options already set in db
char ndb_mapFileResize(void* db, NDB_LOC size);	//Resizes map to new size
void ndb_mapFileClose(void* db);				//Closes the file and memory map

long ndb_getPageSize();		//Get the OS page size - System-Specific!

#endif
//EOF

