/**************************************************************************************

                            Table Manipulation Functions

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_TABLE
#	define NDB_TABLE

#include "ndb_def.h"

//Creates a new table with fieldnum amount of fields. Returns the table number
uint8_t ndb_tableMk(nDB* db, uint8_t fieldnum, char* name);

//Finds the table with the given name
uint8_t ndb_tableFind(nDB* db, char* name);

//Sets a table's field with the given values
void ndb_tfieldSet(nDB* db, NDB_LOC tbl, uint8_t fieldnum, uint8_t type, char* name);

//Gets the table location
NDB_LOC ndb_tableLoc(nDB* db,uint8_t tbl);

//Finds the field with the given name in the table
uint8_t ndb_tfieldFind(nDB* db, NDB_LOC tbl, char* name);

//Gets the field name - this is unsafe, to use for more than one comparison, since
//	the memory can be reallocated at any moment - and changing the variables
//	is strictly forbidden!
char* ndb_tfieldName(nDB* db,NDB_LOC tbl,uint8_t field);
char* ndb_tableName(nDB* db, NDB_LOC tbl);

//Gets the field type
uint8_t ndb_tfieldType(nDB* db, NDB_LOC tbl, uint8_t field);


#endif
//EOF

