/**************************************************************************************

                                    Tree Index

**************************************************************************************/
//Tab Width: 4 Character:\t

#include "treeIndex.h"

#include "allocator.h"
#include "offsets.h"

//------------------------------------------------------------------------------------

//Create an index page
NDB_LOC ndb_tiMk(nDB* db,NDB_LOC prev, uint8_t link) {
	NDB_LOC l;
	assert(db);
	
	ndb_log(NDB_LSTR,"TINDEX: Creating Page\n");
	
	l = ndb_alloc(db,NDB_TINDEXSIZE);
	
	if (!l) {
		ndb_log(NDB_LSTR,"Tindex: Failed to allocate\n");
		return 0;
	}
	
	ndb_otiID(db,l) = 'T';
	ndb_otiPrev(db,l) = prev;
	ndb_otiLnk(db,l) = link;
	
	//We are good
	return l;
}
//Gets the "previous page
NDB_LOC ndb_tiPrev(nDB* db,NDB_LOC pg) {
	assert(db && pg);
	
	if (ndb_otiID(db,pg)!='T') {
		ndb_log(NDB_LSTR,"TINDEX: Page corrupted!\n");
		ndb_errSet(db,16);
		return 0;
	}
	return ndb_otiPrev(db,pg);
}

//Gets the link
uint8_t ndb_tiLink(nDB* db,NDB_LOC pg) {
	assert(db && pg);
	
	if (ndb_otiID(db,pg)!='T') {
		ndb_log(NDB_LSTR,"TINDEX: Page corrupted!\n");
		ndb_errSet(db,16);
		return 0;
	}
	return ndb_otiLnk(db,pg);
}

//Set loc in tree
void ndb_tiAdd(nDB* db, NDB_LOC index, uint8_t lnk, NDB_LOC pg) {
	assert(db && pg);
	
	ndb_log(NDB_LSTR,"TINDEX: Adding to TreeIndex\n");
	
	if (ndb_otiID(db,index)!='T') {
		ndb_log(NDB_LSTR,"tindex: Page corrupted!\n");
		ndb_errSet(db,16);
		return;
	}
	ndb_otiGet(db,index,lnk) = pg;
}

//Returns loc in tree
NDB_LOC ndb_tiLoc(nDB* db, NDB_LOC index, uint8_t lnk) {
	assert(db && index);
	
	ndb_log(NDB_LSTR,"TINDEX: Adding to TreeIndex\n");
	
	if (ndb_otiID(db,index)!='T') {
		ndb_log(NDB_LSTR,"tindex: Page corrupted!\n");
		ndb_errSet(db,16);
		return 0;
	}
	return ndb_otiGet(db,index,lnk);
}



//EOF

