/**************************************************************************************

                           Verbose Memory Allocation Output

**************************************************************************************/
//Tab Width: 4 Character:\t

#define NDB_MVER_H		//We don't want the header to screw us up
#include "ndb_def.h"	//Have to obtain the log file, don't we!

#if defined(NDB_MVER) && NDB_HASLOG

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdint.h>

void* m_malloc(size_t s,char* loc,int line) {
	void* ptr = malloc(s);
	ndb_log(1,"\n(MALLOC Ptr:%-16lu| Size:%-5zu | Loc:%s:%d )",(uint64_t)ptr,s,loc,line);
	return ptr;
}

void m_free(void* ptr,char* loc,int line) {
	ndb_log(1,"\n(FREE   Ptr:%-16lu| Loc:%s:%d )",(uint64_t)ptr,loc,line);
	free(ptr);
}

void m_memset(void* ptr, int n, size_t len, char* loc,int line) {
	ndb_log(1,"\n(MEMSET Ptr:%-16lu| Size:%-5zu | Loc:%s:%d )",(uint64_t)ptr,len,loc,line);
	memset(ptr,n,len);
}
void* m_realloc(void* pointer,size_t s, char* loc,int line) {
	void* ptr = realloc(pointer,s);
	ndb_log(1,"\n(RALLOC Ptr:%lu -> %lu | NewSize:%-5zu | Loc:%s:%d )",(uint64_t)pointer,(uint64_t)ptr,s,loc,line);
	return ptr;
}
void* m_calloc(size_t s, int num, char* loc,int line) {
	void* ptr = calloc(s,num);
	ndb_log(1,"\n(CALLOC Ptr:%-16lu| Size:%-5zu | Loc:%s:%d )",(uint64_t)ptr,s,loc,line);
	return ptr;
}

#endif
//EOF

