/**************************************************************************************

                                      HeapStruct
                               Methods to access Data

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_HEAP
#	define NDB_HEAP

//Includes standard definitions
#include "ndb_def.h"

#define NDB_HSIZE uint32_t
#define NDB_HASIZE 0.5

//Read and write the HSIZE
#define ndb_pgwhs ndb_pgwu32
#define ndb_pgrhs ndb_pgru32

//-------------------------------------------------------------------------------------

NDB_PGNUM ndb_mkHeap(nDB* db);

NDB_FLOC ndb_heapAlloc_(nDB* db, NDB_HSIZE size);	//Allocates memory for the size
NDB_FLOC ndb_heapWrite_(nDB* db, NDB_FLOC loc,void* object,NDB_HSIZE size,NDB_HSIZE offset);	//Writes
uint8_t ndb_heapRead_(nDB* db,NDB_FLOC loc,void* object,NDB_HSIZE size,NDB_HSIZE offset);	//Reads

char ndb_heapCopy_(nDB* db, NDB_FLOC to,NDB_HSIZE offsetTo,NDB_FLOC from,NDB_HSIZE offsetFrom,NDB_HSIZE size);	//Copies data from one to another

char ndb_heapCmp(nDB* db, NDB_FLOC heaploc, NDB_HSIZE offset,void* object, NDB_HSIZE size);	//Compares parts
uint8_t ndb_heapStrcmp(nDB* db, NDB_FLOC hloc, char* string);								//Compares strings

NDB_HSIZE ndb_heapSize(nDB* db, NDB_FLOC loc);

//No-Log versions of the functions
#define ndb_heapAlloc ndb_heapAlloc_
#define ndb_heapWrite ndb_heapWrite_
#define ndb_heapRead ndb_heapRead_
#define ndb_heapCopy ndb_heapCopy_

#endif
//EOF

