/**************************************************************************************

                                 Core of the Database
                                     Definitions

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_CORE 
#	define NDB_CORE

#include "ndb_def.h"

#define NDB_READONLY 1

//Opens a new database
nDB* ndb_open(char* file,uint8_t options);
char ndb_open_v2_(nDB* db, char* file,uint8_t options);

//Close database
void ndb_close(nDB* db);
void ndb_close_v2_(nDB* db);

//Creates an identical copy of the database either to file or to memory
nDB* ndb_copy_(nDB* db, char* filename);

#if NDB_LOG

#define ndb_open_v2(a,b,c) ndb_open_v2__(a,b,c,NDB_LD)
#define ndb_close_v2(a) ndb_close_v2__(a,NDB_LD)
#define ndb_copy(a,b) ndb_copy__(a,b,NDB_LD)

char ndb_open_v2__(nDB* db, char* file,uint8_t options,NDB_LF);
void ndb_close_v2__(nDB* db,NDB_LF);

nDB* ndb_copy__(nDB* db, char* filename,NDB_LF);

#else

#define ndb_open_v2 ndb_open_v2_
#define ndb_close_v2 ndb_close_v2_
#define ndb_copy ndb_copy_

#endif

#endif

//EOF

