/**************************************************************************************

                                  nDB Graph Edge

**************************************************************************************/
//Tab Width: 4 Character:\t

#include "edge.h"
#include "allocator.h"	//For pointer manipulators
#include <string.h>		//memset

void ndb_edgeMk_(nDB* db, NDB_LOC l,uint8_t num, NDB_LOC from, NDB_LOC to) {
	assert(db && l);
	ndb_edgeSetfrom_(db,l,from);
	ndb_edgeSetto_(db,l,to);
	ndb_edgeSetsnum_(db,l,num);
}

void ndb_edgeClear_(nDB* db, NDB_LOC e) {
	assert(db && e);
	memset(ndb_ptr(db,e),0,NDB_EDGESIZE);	//Just sets the memory to 0
}

uint8_t ndb_edgeGetsnum(nDB* db, NDB_LOC l) {
	assert(db && l);
	return ndb_pu8(db,l+1);
}

NDB_LOC ndb_edgeGetfrom(nDB* db, NDB_LOC e) {
	assert(db && e);
	return ndb_ploc(db,e+2);
}

NDB_LOC ndb_edgeGetto(nDB* db, NDB_LOC e) {
	assert(db && e);
	return ndb_ploc(db,e+2+sizeof(NDB_LOC));
}

NDB_LOC ndb_edgeGetdata(nDB* db, NDB_LOC e) {
	assert(db && e);
	return ndb_ploc(db,e+2+2*sizeof(NDB_LOC));
}

void ndb_edgeSetsnum_(nDB* db, NDB_LOC l, uint8_t num) {
	assert(db && l);
	ndb_pu8(db,l+1)=num;
}

void ndb_edgeSetfrom_(nDB* db, NDB_LOC e,NDB_LOC from) {
	assert(db && e);
	ndb_ploc(db,e+2)=from;
}

void ndb_edgeSetto_(nDB* db, NDB_LOC e, NDB_LOC to) {
	assert(db && e);
	ndb_ploc(db,e+2+sizeof(NDB_LOC))=to;
}

void ndb_edgeSetdata_(nDB* db, NDB_LOC e, NDB_LOC data) {
	assert(db && e);
	ndb_ploc(db,e+2+2*sizeof(NDB_LOC))=data;
}

#if NDB_LOG

void ndb_edgeMk__(nDB* db, NDB_LOC e,uint8_t num, NDB_LOC from, NDB_LOC to,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| EDGE make at %lu, %lu->%lu\n",f,l,e,from,to);
	ndb_edgeMk_(db,e,num,from,to);
}
void ndb_edgeClear__(nDB* db, NDB_LOC e,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| EDGE %lu: clear\n",f,l,e);
	ndb_edgeClear_(db,e);
}
void ndb_edgeSetsnum__(nDB* db, NDB_LOC e, uint8_t num,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| EDGE %lu: set 'num'<-%lu\n",f,l,e,num);
	ndb_edgeSetsnum_(db,e,num);
}
void ndb_edgeSetfrom__(nDB* db, NDB_LOC e,NDB_LOC from,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| EDGE %lu: set 'from'<-%lu\n",f,l,e,from);
	ndb_edgeSetfrom_(db,e,from);
}
void ndb_edgeSetto__(nDB* db, NDB_LOC e, NDB_LOC to,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| EDGE %lu: set 'to'<-%lu\n",f,l,e,to);
	ndb_edgeSetto_(db,e,to);
}
void ndb_edgeSetdata__(nDB* db, NDB_LOC e, NDB_LOC data,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| EDGE %lu: set 'data'<-%lu\n",f,l,e,data);
	ndb_edgeSetdata_(db,e,data);
}

#endif
//EOF

