/**************************************************************************************

                                 Database Header
                                    Definitions

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_HEADER
#	define NDB_HEADER

#include "ndb_def.h"	//Includes nDB definitions

//Checks if a file is a database
char ndb_checkFile_(char* filename);

//Writes the default header
void ndb_hwrite_(nDB* db);

//Gets and sets the database ending location
NDB_LOC ndb_hgetEnd(nDB* db);
void ndb_hsetEnd_(nDB* db, NDB_LOC end);

//Gets and sets the tables structure pointer
NDB_LOC ndb_hgetTables(nDB* db);
void ndb_hsetTables_(nDB* db, NDB_LOC tbl);

//Gets and sets the nodes pointer
NDB_LOC ndb_hgetNodes(nDB* db);
void ndb_hsetNodes_(nDB* db, NDB_LOC end);

//Gets and sets the trash list's pointer
NDB_LOC ndb_hgetTrash(nDB* db);
void ndb_hsetTrash_(nDB* db, NDB_LOC end);

#if NDB_LOG

#define ndb_checkFile(a) ndb_checkFile__(a,NDB_LD)
#define ndb_hwrite(a) ndb_hwrite__(a,NDB_LD)
#define ndb_hsetEnd(a,b) ndb_hsetEnd__(a,b,NDB_LD)
#define ndb_hsetTables(a,b) ndb_hsetTables__(a,b,NDB_LD)
#define ndb_hsetNodes(a,b) ndb_hsetNodes__(a,b,NDB_LD)
#define ndb_hsetTrash(a,b) ndb_hsetTrash__(a,b,NDB_LD)

char ndb_checkFile__(char* filename,NDB_LF);
void ndb_hwrite__(nDB* db,NDB_LF);
void ndb_hsetEnd__(nDB* db, NDB_LOC end,NDB_LF);
void ndb_hsetTables__(nDB* db, NDB_LOC tbl,NDB_LF);
void ndb_hsetNodes__(nDB* db, NDB_LOC end,NDB_LF);
void ndb_hsetTrash__(nDB* db, NDB_LOC end,NDB_LF);


#else

#define ndb_checkFile ndb_checkFile_
#define ndb_hwrite ndb_hwrite_
#define ndb_hsetEnd ndb_hsetEnd_
#define ndb_hsetTables ndb_hsetTables_
#define ndb_hsetNodes ndb_hsetNodes_
#define ndb_hsetTrash ndb_hsetTrash_

#endif

#endif
//EOF

