/**************************************************************************************

                                   nDB Node Struct

**************************************************************************************/
//Tab Width: 4 Character:\t

#include "node.h"
#include "allocator.h"

//-------------------------------------------------------------------------------------

NDB_LOC ndb_nodeMk_(nDB* db) {
	NDB_LOC ptr;
	assert(db);
	ptr = ndb_alloc(db,NDB_NODESIZE);	//No initialization other than allocation is necessary
	return ptr;
}

NDB_LOC ndb_nodegetData(nDB* db, NDB_LOC n) {
	assert(db && n);
	return ndb_ploc(db,n+1);
}
void ndb_nodesetData_(nDB* db, NDB_LOC n, NDB_LOC s) {
	assert(db && n);
	ndb_ploc(db,n+1) = s;
}

NDB_LOC ndb_nodegetSeq(nDB* db, NDB_LOC n) {
	assert(db && n);
	return ndb_ploc(db,n+1+sizeof(NDB_LOC));
}
uint64_t ndb_nodegetSeqnum(nDB* db, NDB_LOC n) {
	assert(db && n);
	return ndb_pu64(db,n+1+2*sizeof(NDB_LOC));
}
void ndb_nodesetSeq_(nDB* db, NDB_LOC n, NDB_LOC s) {
	assert(db && n);
	ndb_ploc(db,n+1+sizeof(NDB_LOC)) = s;
}
void ndb_nodesetSeqnum_(nDB* db, NDB_LOC n, uint64_t s) {
	assert(db && n);
	ndb_pu64(db,n+1+2*sizeof(NDB_LOC)) = s;
}

NDB_LOC ndb_nodegetLnk(nDB* db, NDB_LOC n) {
	assert(db && n);
	return ndb_ploc(db,n+1+2*sizeof(NDB_LOC)+sizeof(uint64_t));
}
void ndb_nodesetLnk_(nDB* db, NDB_LOC n, NDB_LOC s) {
	assert(db && n);
	ndb_ploc(db,n+1+2*sizeof(NDB_LOC)+sizeof(uint64_t))=s;
}



#if NDB_LOG

NDB_LOC ndb_nodeMk__(nDB* db,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| NODE: Create node struct\n",f,l);
	return ndb_nodeMk_(db);
}
void ndb_nodesetData__(nDB* db, NDB_LOC n, NDB_LOC s,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| NODE %lu: Set data %lu->%lu\n",f,l,n,ndb_nodegetData(db,n),s);
	ndb_nodesetData_(db,n,s);
}
void ndb_nodesetSeq__(nDB* db, NDB_LOC n, NDB_LOC s,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| NODE %lu: Set sequence %lu->%lu\n",f,l,n,ndb_nodegetSeq(db,n),s);
	ndb_nodesetSeq_(db,n,s);
}
void ndb_nodesetSeqnum__(nDB* db, NDB_LOC n, uint64_t s,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| NODE %lu: Set sequence number %lu->%lu\n",f,l,n,ndb_nodegetSeqnum(db,n),s);
	ndb_nodesetSeqnum_(db,n,s);
}
void ndb_nodesetLnk__(nDB* db, NDB_LOC n, NDB_LOC s,NDB_LF) {
	ndb_ilog(NDB_LSTR,"%8.8s:%-4d| NODE %lu: Set link %lu->%lu\n",f,l,n,ndb_nodegetLnk(db,n),s);
	ndb_nodesetLnk_(db,n,s);
}

#endif



//EOF

