/**************************************************************************************

                                   nDB Node Struct

**************************************************************************************/
//Tab Width: 4 Character:\t

#include "ndb_def.h"

#ifndef NDB_NODE
#	define NDB_NODE

/*

Node Page:
uint8 booleans,NDB_LOC data, NDB_LOC sequence link, uint64 seqsize,NDB_LOC link,uint8_t tablenum

*/

#define NDB_NODESIZE (1+3*sizeof(NDB_LOC)+sizeof(uint64_t)+1)

NDB_LOC ndb_nodeMk_(nDB* db);

//Since the boolean is the first thing in each node, it can just redefine the boolfuncs
#define ndb_nodegetbool ndb_miscGetbool
#define ndb_nodeSetbool ndb_miscSetbool
#define ndb_nodeFlipbool ndb_miscFlipbool

NDB_LOC ndb_nodegetData(nDB* db, NDB_LOC n);
void ndb_nodesetData_(nDB* db, NDB_LOC n, NDB_LOC s);

NDB_LOC ndb_nodegetSeq(nDB* db, NDB_LOC n);
uint64_t ndb_nodegetSeqnum(nDB* db, NDB_LOC n);
void ndb_nodesetSeq_(nDB* db, NDB_LOC n, NDB_LOC s);
void ndb_nodesetSeqnum_(nDB* db, NDB_LOC n, uint64_t s);

NDB_LOC ndb_nodegetLnk(nDB* db, NDB_LOC n);
void ndb_nodesetLnk_(nDB* db, NDB_LOC n, NDB_LOC s);

uint8_t ndb_nodegetTable(nDB* db, NDB_LOC n);
void ndb_nodesetTable_(nDB* db, NDB_LOC n,uint8_t tbl);

#if NDB_LOG

#define ndb_nodeMk(a) ndb_nodeMk__(a,NDB_LD)
#define ndb_nodesetData(a,b,c) ndb_nodesetData__(a,b,c,NDB_LD)
#define ndb_nodesetSeq(a,b,c) ndb_nodesetSeq__(a,b,c,NDB_LD)
#define ndb_nodesetSeqnum(a,b,c) ndb_nodesetSeqnum__(a,b,c,NDB_LD)
#define ndb_nodesetLnk(a,b,c) ndb_nodesetLnk__(a,b,c,NDB_LD)

NDB_LOC ndb_nodeMk__(nDB* db,NDB_LF);
void ndb_nodesetData__(nDB* db, NDB_LOC n, NDB_LOC s,NDB_LF);
void ndb_nodesetSeq__(nDB* db, NDB_LOC n, NDB_LOC s,NDB_LF);
void ndb_nodesetSeqnum__(nDB* db, NDB_LOC n, uint64_t s,NDB_LF);
void ndb_nodesetLnk__(nDB* db, NDB_LOC n, NDB_LOC s,NDB_LF);

#else

#define ndb_nodeMk ndb_nodeMk_
#define ndb_nodesetData ndb_nodesetData_
#define ndb_nodesetSeq ndb_nodesetSeq_
#define ndb_nodesetSeqnum ndb_nodesetSeqnum_
#define ndb_nodesetLnk ndb_nodesetLnk_

#endif

#endif
//EOF

