/**************************************************************************************

                                 Core of the Database
                                     Definitions

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_CORE 
#	define NDB_CORE

#include "ndb_def.h"

#define NDB_READONLY 1

//Opens a new database
nDB* ndb_open(char* file);
char ndb_open_v2(nDB* db, char* file, uint8_t options);

//Close database
void ndb_close(nDB* db);
void ndb_close_v2(nDB* db);

//Creates an identical copy of the database either to file or to memory
nDB* ndb_copy(nDB* db, char* filename);

//-----------------------------------------------------------------------------------

//Get the database compiled identifier - so that it can recognize if another database
//	was made by one with incompatible parameters
uint8_t ndb_getComp();

//Checks if a file is a database
char ndb_checkFile(char* filename);

//Writes the default header to map
void ndb_hwrite(nDB* db);

#endif
//EOF

