/**************************************************************************************

                                Error Handling
                                Implementation

**************************************************************************************/
//Tab Width: 4 Character:\t

#include "error.h"

#if NDB_LOG
#include <errno.h>	//Allows to obtain system error information
#include <string.h>	//For writing the error as string to log
#endif

//-------------------------------------------------------------------------------------

void ndb_errSetSys(nDB* db) {
	assert(db);
	
	ndb_log(NDB_LERR,"ERR: %s\n",strerror(errno));
	
	//This function sets db->err to 255 meaning that there is an errno
	db->err = 255;
}

void ndb_errSet(nDB* db, uint8_t errnum) {
	assert(db);
	
	ndb_log(NDB_LERR,"ERR: %u\n",errnum);
	
	db->err = errnum;
}

uint8_t ndb_errGet(nDB* db) {
	uint8_t e;
	assert(db);
	e = db->err;
	db->err = 0;
	return e;
}

uint8_t ndb_errPeek(nDB* db) {
	assert(db);
	return db->err;
}

//EOF

