/**************************************************************************************

                                     Logging
                                  Implementation

**************************************************************************************/
//Tab Width: 4 Character:\t

#include "log.h"

//-------------------------------------------------------------------------------------


#if NDB_LOG	//Only include the functions if they are necessary!

#include <stdarg.h>		//Allows for multiargument functions

FILE* logfile = (FILE*)-1;	//The log file is stdout by default, but it has to be initialized
uint8_t loglevel = 1;		//The level at which to log messages

FILE* ndb_logGetFile() {
	if (logfile==(FILE*)-1) logfile = stdout;
	return logfile;
}

void ndb_logSetFile(FILE* f) {
	ndb_log(NDB_LLOG,"LOG: Set new log file\n");
	logfile = f;
}

uint8_t ndb_logGetLevel() {
	return loglevel;
}

void ndb_logSetLevel(uint8_t level) {
	ndb_log(NDB_LLOG,"LOG: Changed log level to %u\n",level);
	loglevel = level;
}

void ndb_log_(char* f, uint32_t l, uint8_t level, char* str, ...) {
	if (logfile ==(FILE*)-1) logfile=stdout;	
	
	if (level >= loglevel && logfile) {
		va_list a_list;
#ifdef NDB_LOGFLINE							//Print the file and line number if supposed to
		fprintf(logfile,"%8.8s:%-4d| ",f,l);
#endif
		va_start(a_list,str);
		vfprintf(logfile,str,a_list);
		va_end(a_list);
		//fprintf(logfile,"\n");	//The \n disallowed adding on to message as search happens
#ifdef NDB_LOGFLUSH
		fflush(logfile);
#endif
	}
}

//This is exactly the same as ndb_log, except it is used to fill in statements!
void ndb_slog(uint8_t level,char* str, ...) {
	if (logfile ==(FILE*)-1) logfile=stdout;
	
	if (level >= loglevel && logfile) {
		va_list a_list;
		va_start(a_list,str);
		vfprintf(logfile,str,a_list);
		va_end(a_list);
#ifdef NDB_LOGFLUSH
		fflush(logfile);
#endif
	}
}

#endif

//EOF

