/**************************************************************************************

                                   OS-Specifics
                                    Definition

**************************************************************************************/
//Tab Width: 4 Character:\t
#ifndef N2_EXTRAS
#define N2_EXTRAS 1
/*
The goal of these functions is to provide an as-close-to OS-independent method to obtain
multiple necessary values as possible. It should also enable a decent C-standard fallback
if none of the OSs are available.
*/

#include <stdint.h>	//We want the OS-independent integer types

//-------------------------------------------------------------------------------------
//Multithreading

/*
This is the most dangerous part of the extras, since if threading is disabled
*/


uint8_t thrd_cores();	//Get the number of CPU cores available


//-------------------------------------------------------------------------------------
//Timer

uint64_t tmr_millis();	//Returns a millisecond value - it is only to be used for differences
						//	in times in one run.

#endif
//EOF

