/**************************************************************************************

                                   nDB Linkstruct
                                  Link Manipulator

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifdef NDB_LINKSTRUCT
#	define NDB_LINKSTRUCT

#include "ndb_def.h"

/*
The Linkstruct is used to store and manipulate the link classes

The structure of a linkstruct node:
NDB_LINK is assumed to be uint8_t for this explanation

max(NDB_LINK)->255

It is quite literally in order:
NDB_LOC+255*NDB_LOC+NDB_LOC+NDB_LINK
^1		^2			^3		^4
1) The 0th link - links to the sequence struct for that node
2) The 255 links - link to the further nodes
3) The last link - links to the previous node
4) The number of the current node

*/

//lsGoto: 
//	Goes to the given NULL-terminated address, starting at root.
//	If the address exists, just follows the links to it, if it does
//	not, then it creates the remaining addresses.
//	The array is NULL-terminated because link sequences are the 0th link!
NDB_LOC ndb_lsGoto_(nDB* db, NDB_LINK* address, NDB_LOC root);

//These search through existing pages and create new ones
NDB_LOC ndb_lsgExisting_(nDB* db, NDB_LINK* address, NDB_LOC root,uint32_t* iter);
NDB_LOC ndb_lsgMakenew_(nDB* db, NDB_LINK* address, NDB_LOC root);

//Linkspace page creation
NDB_LOC ndb_lsAddpage_(nDB* db,NDB_LOC prev, NDB_LINK classid);

//LinkSpacePage macros - allow simple access to the page's parts
//	They are macros, so they don't do any type of check - and the database
//	really HAS no way of checking pointers, since I have decided not to mess 
//	around with identifiers (yet)

#define ndb_lspNum(db,loc,num) (*(NDB_LOC*)((db)->map+(loc)+(num)*sizeof(NDB_LOC)))
#define ndb_lspPrev(db,loc) (*(NDB_LOC*)((db)->map+(loc)+256*sizeof(NDB_LOC)))
#define ndb_lspClass(db,loc) (*(NDB_LINK*)((db)->map+(loc)+257*sizeof(NDB_LOC)))

//Link manipulation functions

uint32_t ndb_linkLen(NDB_LINK* address);
NDB_LINK* ndb_linkCpy(NDB_LINK* address);

#if NDB_LOG
#else



#endif

#endif
//EOF

