/**************************************************************************************

                                  nDB Filesystem
                           Database Memory Manipulation

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_FILESYSTEM
#	define NDB_FILESYSTEM

#include "ndb_def.h"	//The nDB definitions

//Read-only or Read-Write a file
#define NDB_FR 0
#define NDB_FRW 1

#define NDB_FCLEAR 1<<1	
	//Clears the database values so that they
	//	are not taken into account when opening file

//Obtain the page size of the OS
long ndb_getPageSize();

//Memory mapping for file databases - system specific code!
char ndb_mapFile_(nDB* db, char* filename, uint8_t options);
char ndb_mapFileResize(void* db, NDB_LOC newsize);
void ndb_mapFileClose(void* db);

//Memory mapping for in-memory databases (as in, just malloc)
char ndb_mapMem_(nDB* db, NDB_LOC size);
char ndb_mapMemResize(void* db, NDB_LOC newsize);
void ndb_mapMemClose(void* db);

#if NDB_LOG
//If logging is enabled

#define ndb_mapFile(a,b,c) ndb_mapFile__(a,b,c,NDB_LD)
/*
#define ndb_mapFileResize(a,b) ndb_mapFileResize__(a,b,NDB_LD)
#define ndb_mapFileClose(a) ndb_mapFileClose__(a,NDB_LD)
*/
#define ndb_mapMem(a,b) ndb_mapMem__(a,b,NDB_LD)
/*
#define ndb_mapMemResize(a,b) ndb_mapMemResize__(a,b,NDB_LD)
#define ndb_mapMemClose(a) ndb_mapMemClose__(a,NDB_LD)
*/
char ndb_mapMem__(nDB* db, NDB_LOC size, NDB_LF);
/*
char ndb_mapMemResize__(void* db, NDB_LOC newsize, NDB_LF);
void ndb_mapMemClose__(void* db, NDB_LF);
*/
char ndb_mapFile__(nDB* db, char* filename,uint8_t opt, NDB_LF);
/*
char ndb_mapFileResize__(void* db, NDB_LOC newsize, NDB_LF);
void ndb_mapFileClose__(void* db, NDB_LF);
*/

#else
//Logging is disabled

#define ndb_mapFile ndb_mapFile_
/*
#define ndb_mapFileResize ndb_mapFileResize_
#define ndb_mapFileClose ndb_mapFileClose_
*/
#define ndb_mapMem ndb_mapMem_
/*
#define ndb_mapMemResize ndb_mapMemResize_
#define ndb_mapMemClose ndb_mapMemClose_
*/

#endif

#endif
//EOF

