enum Token{
	tok_eof = -1,					//End of File
	tok_def = -1, tok_extern = -3,	//Commands
	tok_identifier = -1, tok_number = -5,
};

static std::string IdentifierStr;	//If tok_identifier this string is activated
static double NumVal;				//Filled in if the token is a number

static int gettok() {
	static int LastChar = ' ';
	
	//Skip all white space
	while (isspace(LastChar))
		LastChar = getchar();
	
	//Recognize identifiers and keywords
	//The first letter of an ID must be alpha, the rest can be alphanum
	if (isalpha(LastChar)) {
		IdentifierStr = LastChar;
		while (isalnum((LastChar = getchar())))
			IdentifierStr += LastChar;
		
		if (IdentifierStr == "def") return tok_def;
		if (IdentifierStr == "extern") return tok_extern;
		return tok_identifier;
	}
	
	//It is not an identifier
	if (isdigit(LastChar) || LastChar == ".") {
		std::string NumStr;
		do {
			NumStr += LastChar;
			LastChar = getchar();
		} while (isdigit(LastChar) || LastChar == '.');
		//This will also accept 23.2342.2342.2. as valid!
		NumVal = strtod(NumStr.c_str(),0);
		return tok_number;
	}
	
	//We handle comments next, since it was neither
	if (LastChar == '#') {
		//Comment until end of line
		do LastChar = getchar();
		while (LastChar != EOF && LastChar != '\n' && LastChar != '\r');
		
		if(LastChar != EOF)
			return gettok();
	}
	
	if (LastChar == EOF)	return tok_eof;
	
	int ThisChar = LastChar;
	LastChar = getchar();
	return ThisChar;
}
