/**************************************************************************************

                         Allocation for Database Structures
                                    Definitions

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_ALLOC
#	define NDB_ALLOC

#include "ndb_def.h"

//Allocates the given amount from the file, returning a file offset for the allocated section
NDB_LOC ndb_alloc(nDB* db, NDB_SIZE size);

//Frees the given size from location - the allocator does not remember how much it allocated,
//	so size must be passed. This allows for lowering allocation size, and speeds up most database
//	structure, because most database parts have a fixed (known) size
void ndb_free(nDB* db, NDB_LOC loc, NDB_SIZE size);

//This is not a powerful reallocator - it literally allocates a new region and copies the data to it
NDB_LOC ndb_ralloc(nDB* db, NDB_LOC old, NDB_SIZE oldsize, NDB_SIZE newsize);

#endif
//EOF

