/**************************************************************************************

                       The Query Parser and Generator

**************************************************************************************/
//Tab Width: 4 Character:\t

#include "query.h"

/*
	The Query parser is made to most easily access the database. Examples of queries:
	
	CREATE TABLE lol (string hai,int64 trollolol);
	MKTBL lol (hai string, trollolol int64)
	
	CREATE NODE WITH TABLE lol;
	MKNODE $lol
	
	CREATE LINK WITH TABLE lol IN SEQUENCE 2342342 LINKING 324324 AND 3423424;
	MKLNK $lol @2342342 324324->3423424
	
	SELECT * WHERE NODE AND TABLE==lol AND hai="omg";
	SELECT NODE & $lol & hai=='omg'
	
	SET hai=trollolol trollolol=%i WHERE LINK AND TABLE=lol AND hai != 'omg'
	SET hai=trollolol trollolol=%i WHERE $lol && hai <> 'omg'
	
	Furthermore, since it is unusual structure, we can set the node or link table
	like that too
	SET TABLE=lol WHERE TABLE!=lol
	SET $lol WHERE !$lol
	
	Note that TABLE is set in the WHERE, that means that multiple tables can be
	searched with the same query, so if 2 tables have a 'hai' column,
	SELECT hai;
	Gives you all entries that HAVE a hai column
	SELECT hai=5
	Gives you all entries where the hai column is 5 or an equivalent
	
	You have to be careful with the SET command, since it can set things equal, so
	SET hai=tro
	Sets the column hai, if such exists to the value of column tro. If tro does not
	exist in that particular table, it does not set hai. This is border case, and it
	is better to explicitly state existence:
	SET hai=tro WHERE hai AND tro
	This is actually what that first command expands to.
	
	Conditionals and stuff like that works just like anywhere else, and different
	parentheses work, so
	SELECT ($lol OR TABLE==goo) AND (hai!='lol' || (sup!=hai))
	
	Furthermore, you can have SET statements and the like both set and iterate with
	SET $lol SELECT *
	This statementsets each node and link's table to lol, and after setting each, it
	iterates through. Warning: Only the *CURRENT* node will be set during iteration,
	since it iterates WHILE setting.
*/
//-------------------------------------------------------------------------------------

//Parses a database SQL-like statement into a query-tree
ndb_query* ndb_statement(nDB* db, char* q) {
	return NULL;
}

//Obtains the next element that fit the query in the tree
NDB_LOC ndb_queryGet(ndb_query* q) {
	return 0;
}

//Resets the query so that it can be used again
void ndb_queryReset(ndb_query* q) {
	//return NULL;
}

//Frees all memory associated with the query
void ndb_queryFree(ndb_query* q) {
	
}

//EOF

