/**************************************************************************************

                              NDB Logging Header File

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_LOG_H
#	define NDB_LOG_H

#include <stdio.h>
#include <stdint.h>

uint8_t ndb_getLogLevel();
void ndb_setLogLevel(uint8_t level);

FILE* ndb_getLogFile();			//Obtains the ndb log file
void ndb_setLogFile(FILE* f);	//Changes the ndb log file to the given. Note: ndb makes no attempt
								//	to close any log files, so they must be manually closed!

//The actual logging function
void ndb_log(uint8_t level,char* str,...);

#endif

//Memory allocation logging
#if defined(NDB_MVER) && !defined(NDB_MVER_H) && NDB_HASLOG
#define NDB_MVER_H

#include <stdlib.h>
#include <string.h>

void* m_malloc(size_t s,char* loc,int line);
void m_free(void* ptr,char* loc,int line);
void m_memset(void* ptr, int n, size_t len, char* loc,int line);
void* m_realloc(void* pointer,size_t size, char* loc,int line);
void* m_calloc(size_t size, int num, char* loc,int line);

#define malloc(si) m_malloc(si,__FILE__,__LINE__)
#define free(ptr) m_free(ptr,__FILE__,__LINE__)
#define memset(p,n,l) m_memset(p,n,l,__FILE__,__LINE__)
#define realloc(p,n) m_realloc(p,n,__FILE__,__LINE__)
#define calloc(p,n) m_calloc(p,n,__FILE__,__LINE__)

#endif
//EOF

