/**************************************************************************************

                              nDB Edge Sequence Struct

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_SEQPG
#	define NDB_SEQPG

#include "ndb_def.h"

//The Amount of edges that are allowed on a sequence page
#define NDB_SEQEDGES 4
#define NDB_SEQHEADSIZE (3*sizeof(NDB_LOC)+sizeof(uint64_t))
#define NDB_SEQSIZE (NDB_SEQHEADSIZE+NDB_SEQEDGES*NDB_EDGESIZE)

//------------------------------------------------------------------------------------
//Sequence page manipulation functions

NDB_LOC ndb_seqpgMk_(nDB* db,NDB_LOC node);

NDB_LOC ndb_seqpgGetprev(nDB* db, NDB_LOC s);
NDB_LOC ndb_seqpgGetnext(nDB* db, NDB_LOC s);
NDB_LOC ndb_seqpgGetnode(nDB* db, NDB_LOC s);
uint64_t ndb_seqpgGetnum(nDB* db, NDB_LOC s);

void ndb_seqpgSetprev_(nDB* db, NDB_LOC s, NDB_LOC e);
void ndb_seqpgSetnext_(nDB* db, NDB_LOC s, NDB_LOC e);
void ndb_seqpgSetnode_(nDB* db, NDB_LOC s, NDB_LOC e);
void ndb_seqpgSetnum_(nDB* db, NDB_LOC s, uint64_t e);

NDB_LOC ndb_seqpgGetedge(nDB* db, NDB_LOC s, uint8_t num);

#if NDB_LOG

#define ndb_seqpgMk(a,b) ndb_seqpgMk__(a,b,NDB_LD)
#define ndb_seqpgSetprev(a,b,c) ndb_seqpgSetprev__(a,b,c,NDB_LD)
#define ndb_seqpgSetnext(a,b,c) ndb_seqpgSetnext__(a,b,c,NDB_LD)
#define ndb_seqpgSetnode(a,b,c) ndb_seqpgSetnode__(a,b,c,NDB_LD)
#define ndb_seqpgSetnum(a,b,c) ndb_seqpgSetnum__(a,b,c,NDB_LD)

NDB_LOC ndb_seqpgMk__(nDB* db,NDB_LOC node,NDB_LF);
void ndb_seqpgSetprev__(nDB* db, NDB_LOC s, NDB_LOC e,NDB_LF);
void ndb_seqpgSetnext__(nDB* db, NDB_LOC s, NDB_LOC e,NDB_LF);
void ndb_seqpgSetnode__(nDB* db, NDB_LOC s, NDB_LOC e,NDB_LF);
void ndb_seqpgSetnum__(nDB* db, NDB_LOC s, uint64_t e,NDB_LF);

#else

#define ndb_seqpgMk ndb_seqpgMk_
#define ndb_seqpgSetprev ndb_seqpgSetprev_
#define ndb_seqpgSetnext ndb_seqpgSetnext_
#define ndb_seqpgSetnode ndb_seqpgSetnode_
#define ndb_seqpgSetnum ndb_seqpgSetnum_

#endif

#endif
//EOF

