/**************************************************************************************

                             Database Structured Storage
                                     Header

**************************************************************************************/
//Tab Width: 4 Character:\t

#ifndef NDB_TABLES
#	define NDB_TABLES

#include "ndb_def.h"	//The ndb definitions

/*

The tables define certain datatypes. Each "thing" in a table is one of these types:
0 - none, random binary data (size is included)
1 - u8
2 - u16
3 - u32
4 - u64
5 - i8
6 - i16
7 - i32
8 - i64
9 - float
10 - double
11 - text
More datatypes can be later defined

*/

//Size of the tables structure
#define NDB_TABLESSIZE (256*sizeof(NDB_LOC))

//Creates the Tables structure
NDB_LOC ndb_tablesMk_(nDB* db);

//Creates a table with x fields - the table structure has a variable size
NDB_LOC ndb_tableMk_(nDB* db,uint8_t fields);

//Gets field X from table
NDB_LOC ndb_tablegetField(nDB* db,NDB_LOC table, uint8_t num);

NDB_LOC ndb_tablefieldgetName(nDB* db, NDB_LOC table);
void ndb_tablefieldsetName(nDB* db, NDB_LOC table);

#if NDB_LOG

#else

#endif

#endif
//EOF

