%{
#include <stdio.h>
#include <math.h>
#include "nql.tab.h"
//%option reentrant
%}
%option noyywrap
%%
[ \t\n]				;
"NODE"				{	return NODE;	}
"LINK"				{	return LINK;	}
"TABLE"				{	return TABLE;	}

"SET"				{	return SET; 	}
"GET"				{	return GET;		}
"WHERE"				{	return WHERE;	}
"SELECT"			{	return SELECT;	}

("AND"|&&?)			{	return AND;		}
("OR"|\|\|?)		{	return OR;		}

$[a-zA-Z0-9_]+		{	printf("TBL(%s) ",yytext);	}
!$[a-zA-Z0-9_]+		{	printf("!TBL(%s) ",yytext);	}
[0-9]+\.[0-9]+		{	yylval.fval=atof(yytext);	return FLOAT;	}
[0-9]+				{	yylval.ival=atoi(yytext);	return INT;		}
\"(\\.|[^\\"])*\"	{	yylval.sval = strdup(yytext); return STRING;	}
\'(\\.|[^\\'])*\'	{	yylval.sval = strdup(yytext); return STRING;	}

\(					{	return '(';	}
\)					{	return ')';	}

\<					{	return '<';	}
>					{	return '>';	}
(=?!=|\<>)			{	return NEQ;	}
=?<=?				{	return LEQ;	}
=?>=?				{	return GEQ;	}
==					{	return DEQ;	}
=					{	return '=';	}

"*"					{	return '*';}
"/"					{	return '/';}
"+"					{	return '+';	}
"-"					{	return '-';	}
("^"|"**")			{	return '^';}
";"					;
[a-zA-Z0-9_]+		{	yylval.sval = strdup(yytext); return STRING;	}
.					{	yyerror("Unrecognized Entry");	}
%%

int main() {
	char str[100];
	
	YY_BUFFER_STATE sbuf;
	while (1) {
		printf("Parse:");
		fgets(str,sizeof(str),stdin);
		str[strlen(str)+1]='\0';	//Double-NULL terminated
		printf("Parsing:%s",str);
		sbuf = yy_scan_string(str);
		yy_switch_to_buffer(sbuf);
		yyparse();
		yy_delete_buffer(sbuf);
	}
}
